"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class ReportedVsGeneticSummary(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "mendelErrorsTool",
        "mendelErrorsToolVersion",
        "pathToDirectory",
        "relatednessTool",
        "relatednessToolVersion",
        "runDate",
        "rvsgCheckVersion",
        "samplesInfo",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_2 import metrics as metrics_1_2_0

        return {
            "samplesInfo": metrics_1_2_0.SamplesInfo,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_2 import metrics as metrics_1_2_0

        return {
            "genomeAssembly": metrics_1_2_0.SupportedAssembly,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_2 import metrics as metrics_1_2_0

        return {
            "org.gel.models.metrics.avro.SupportedAssembly": metrics_1_2_0.SupportedAssembly,
            "org.gel.models.metrics.avro.SamplesInfo": metrics_1_2_0.SamplesInfo,
            "org.gel.models.metrics.avro.ReportedVsGeneticSummary": metrics_1_2_0.ReportedVsGeneticSummary,
        }

    __slots__ = [
        "mendelErrorsTool",
        "mendelErrorsToolVersion",
        "pathToDirectory",
        "relatednessTool",
        "relatednessToolVersion",
        "runDate",
        "rvsgCheckVersion",
        "samplesInfo",
        "genomeAssembly",
        "numberOfMarkers",
        "numberOfMarkersLE",
    ]

    def __init__(
        self,
        mendelErrorsTool,
        mendelErrorsToolVersion,
        pathToDirectory,
        relatednessTool,
        relatednessToolVersion,
        runDate,
        rvsgCheckVersion,
        samplesInfo,
        genomeAssembly=None,
        numberOfMarkers=None,
        numberOfMarkersLE=None,
        validate=None,
        **kwargs
    ):
        """Initialise the metrics_1_2_0.ReportedVsGeneticSummary model.

        :param mendelErrorsTool:
            Tool used to compute mendelian inconsistencies
        :type mendelErrorsTool: str
        :param mendelErrorsToolVersion:
            Version of the tool used to compute mendelian inconsistencies
        :type mendelErrorsToolVersion: str
        :param pathToDirectory:
            Path to the directory containing the checks for this family
        :type pathToDirectory: str
        :param relatednessTool:
            Tool used to compute within-family relatedness
        :type relatednessTool: str
        :param relatednessToolVersion:
            Version of the tool used to compute mendelian inconsistencies
        :type relatednessToolVersion: str
        :param runDate:
            In the format YYYY-MM-DDTHH:MM:SS+0000
        :type runDate: str
        :param rvsgCheckVersion:
            Reported vs Genetic checks version. This version should point to
            specific versions of the RvsG script, configurations and
            thresholds
        :type rvsgCheckVersion: str
        :param samplesInfo:
            Information about the samples used to calculate the RvsG checks
        :type samplesInfo: list[SamplesInfo]
        :param genomeAssembly:
            Genome assembly
        :type genomeAssembly: None | SupportedAssembly
        :param numberOfMarkers:
            Number of markers used to compute the Mendelian Inconsistencies. This
            corresponds to the number of lines in the PLINK .bim file
            used for this family
        :type numberOfMarkers: None | double
        :param numberOfMarkersLE:
            Number of markers in approximate linkage equilibrium used to calculate
            IBD
        :type numberOfMarkersLE: None | double
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.2.0"
